(*

  ocamlopt -thread unix.cmxa -cclib -lunix -cclib -lpthread threads.cmxa -o pi pi.ml
  ./pi [rayon du cercle] [nb de threads]

*)


(*let pi=
  for x = 0 to (int_of_string Sys.argv.(1)) do
  for y = 0 to (int_of_string Sys.argv.(1)) do
  if 
  int_of_float (sqrt ( ((float x)**2. +. (float y)**2.))) <= (int_of_string Sys.argv.(1)) then
  incr cpt;
  done;
  done
*)

let line = ref 0

let line_m = ref (Mutex.create ())



let pi n nb_th tab idx=
  let b = ref true in 
    while !b do
      (
	Mutex.lock !line_m;
	incr line;
	Mutex.unlock !line_m;
	if !line >= n then  
	  b := false
	else
	  (
	    let y = !line
	    in
	      (
	
		for x = 0 to n-1 do 
		  (*    for y = idx*(n/(nb_th)) to ((idx+1)*(n/nb_th) - 1) do *)
		  (*      let a = (float x )
			  and b = (float y ) in*)
		  if (sqrt ((float x)**2. +. (float y)**2. )) <= (float_of_int n) then 
		    tab.(idx) <- tab.(idx) +1;
		done;
	      )
	  )
      )
    done


let _ = 
  Random.self_init ();
  let n = int_of_float ((float_of_string Sys.argv.(1)) )
  and nb_th = (int_of_string Sys.argv.(2))
  in
  let compteurs = Array.create nb_th ( 0)    in
  let threads = 
    Array.init
      nb_th
      (fun i -> (Thread.create (pi n nb_th compteurs) i ))
  in
    Array.iter Thread.join threads;
    for i = 1 to nb_th-1 do
      compteurs.(0) <- compteurs.(0) + compteurs.(i);
    done;
    Printf.printf "Pi=%g\n"  (4. *. (float compteurs.(0)) /. ((float n)**2.))
      
