type 'a bucket = {
  mutable stock : 'a list;
}


let prod b plop m =
  Mutex.lock m;
  for i = 0 to 10000 do
    ignore(Array.make 1000 1000);
    Mutex.lock plop;
    b.stock <- i :: b.stock;
    Mutex.unlock plop;
  done;
  print_endline "prod ENDED";
  Mutex.unlock m

exception Stop

let cons b plop m xxx =
  Mutex.lock m;
  let plop' = ref 0 in
begin
try
  for i = 0 to 100 do
incr plop';
if !plop' > 100 then raise Stop;
    ignore(Array.make 1000 1000);
    while
      Mutex.lock plop;
      let x =
	begin
	  match b.stock with
	      [] -> true
	    | e::tl ->
		Printf.printf "got %d\n" e;
		flush stdout;
		b.stock <- tl;
		false
	end in
	Mutex.unlock plop;
	x
    do 
      ignore(Array.make 1000 1000);
    done
  done;
with Stop -> ();
end;
Printf.printf "cons ENDED %d\n" xxx;
  Mutex.unlock m

let () =
let b = {stock=[]} in
let plop = Mutex.create () in
let y, x = Mutex.create (), Mutex.create () in
  ignore(Thread.create (prod b plop) y);
  ignore(Thread.create (cons b plop x) 42);
  let () =
    let b = {stock=[]} in
    let plop = Mutex.create () in
    let z = Mutex.create () in
    let t = Mutex.create () in
      prod b plop z;
      cons b plop t 11;
      Mutex.lock x;
      Mutex.lock t;
      Mutex.lock z;
      Mutex.lock y;
  in ()

