let rec intervalle r a b =
 if a > b then r
 else intervalle2 (a::r) (a+1) b

and intervalle2 r a b =
 if a > b then []
 else intervalle (a::r) (a+1) b

let intervalle a b = intervalle [] a b

let prerr_endline _ = ()

module SafeThread = Thread

let maximum = List.fold_left max 0

let compute s =
 let n = 4 in
 let t =
   Array.make n
     (Thread.create (fun () -> prerr_endline "TC") ())
 in
   for i = 0 to 100 / n do
     for j = 0 to n - 1 do
       t.(j) <-
	  Thread.create
	  (fun () ->
	     prerr_endline "TC";
	     maximum (List.map (succ) (intervalle 0 s))) ();
     done;
     Array.iter Thread.join t;
   done;
   List.map maximum
     (List.map (intervalle 0) (intervalle 0 s))

let _ =
  let s = ref 0 in
    for i = 1 to 100 do
      compute !s;
      s:= !s +1
    done;
  print_endline "ok, programme terminé..."
